#include "dcdialog.ch"
#include "dctree.ch"
#include "dcmsg.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "nls.ch"
#include "dll.ch"


procedure main
SET CHARSET TO OEM
SET CONFIRM ON
SET DELETE ON
SET SCORE OFF

DO EXAMPLE

return


PROC appsys ; RETURN


PROCEDURE EXAMPLE
LOCAL aPos:={0,0},aSize:={0,0}
LOCAL GetOptions ,GetList := {}

PRIVATE oDialog,oDarea
PRIVATE oBrowse,oColumn,lStatus,lOFFcursor


aSize:={ 700,550 }
aPos[1]:=10
aPos[2]:=200

oDialog := XbpDialog():New(,, aPos, aSize )
oDialog:Title := "EXAMPLE"
oDialog:minSize:=aSize
oDialog:maxSize:=aSize
oDialog:sysMenu:=.F.
oDialog:hideButton:=.F.
oDialog:border := XBPDLG_THINBORDER
oDialog:Create()

// trick to hide min,max button
oDialog:maxButton:=.F.
oDialog:minButton:=.F.
oDialog:configure()

SetAppFocus(oDialog)
oDarea:=oDialog:drawingArea

lOFFcursor:=.F.

USE ("TEST.DBF") ALIAS DBCLIF NEW
dbgotop()

@  2,2 DCQUICKBROWSE OBJECT oBrowse SIZE 95,18 ID "BROWSE" ;
            CURSORMODE XBPBRW_CURSOR_ROW ALIAS "DBCLIF" ;
            PRESENTATION { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },;                    /// Header FG Color
                                  { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND },;               /// Header BG Color
                                  { XBP_PP_COL_FA_FGCLR, GRA_CLR_YELLOW },;                   /// Footer FG Color
                                  { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },;                 /// Footer BG Color
                                  { XBP_PP_COL_DA_CELLHEIGHT, 20 }}                          /// Cell Height


    DCBROWSECOL FIELD DBCLIF->FIELD_4 Header "field4"   WIDTH 30 PARENT oBrowse OBJECT oColumn
    DCBROWSECOL FIELD DBCLIF->FIELD_1 Header "field1"   WIDTH 5 PARENT oBrowse
    DCBROWSECOL FIELD DBCLIF->FIELD_3 Header "field3"   WIDTH 10 PARENT oBrowse
    DCBROWSECOL FIELD DBCLIF->FIELD_2 Header "field2"   WIDTH 15 PARENT oBrowse

@ 22,1 DCPUSHBUTTON CAPTION "CURSOR ROW ON/OFF" OBJECT oButton1 ;
                    ACTION {||ON_OFF_CURSOR()} SIZE 25,2 PARENT oWindow TABSTOP

@ 22,40 DCPUSHBUTTON CAPTION "INSERT NEW "  ;
                    ACTION {||NEW_ROW()} SIZE 25,2 PARENT oWindow TABSTOP


DCGETOPTIONS NOBUSY CONFIRM NOMINBUTTON NOMAXBUTTON NOTASKLIST NORESIZE


DCREAD GUI TO lStatus OPTIONS GetOptions PARENT oDarea ; // ENTEREXIT ;
       SETFOCUS "BROWSE"

RETURN




STATIC FUNCTION ON_OFF_CURSOR
IF lOFFcursor // view cursor
    lOFFcursor:=.F.
    oBrowse:hilite()
ELSE // hide cursor
    lOFFcursor:=.T.
    oBrowse:deHilite()
ENDIF
RETURN NIL



STATIC FUNCTION NEW_ROW
LOCAL GetOptions ,GetList:={}
LOCAL aSize,aPos,nColPos,nRowPos,nRowHeight,nColumnWidth,nRowWidth
LOCAL oBarEdit,cVar

// go bottom & force panning down to simulate new record
oBrowse:goBottom( .T. )
oBrowse:forceStable()
oBrowse:down(.F.)
oBrowse:forceStable()
oBrowse:deHilite()

// Prepare new empty row
oBrowse:disable()

aSize:=oBrowse:currentSize()
aPos:=oBrowse:currentPos()
nColPos := oBrowse:colPos
nRowPos := oBrowse:rowPos
nRowHeight := oBrowse:getRowHeight()
nColumnWidth := oBrowse:getColWidth( 1 )

// size of row
nRowWidth:=0
FOR nT:=1 TO oBrowse:colCount
    nRowWidth += oBrowse:getColWidth(nT)
NEXT

// showing empty row - GETs are builted here
@  nRowHeight*(nRowPos+2) ,aPos[1] DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT  SIZE nRowWidth,nRowHeight   OBJECT oBarEdit ;
                                            PIXEL PARENT oDarea

// example of two GETs
cVar1:=SPACE(10)
cVar2:=SPACE(15)
@ 0,0  DCGET cVar1 GETSIZE 10  GETID "GET1" PARENT oBarEdit
@ 0,20 DCGET cVar2 GETSIZE 15  PARENT oBarEdit


DCGETOPTIONS  CONFIRM  NOTITLE NORESIZE NOTASKLIST HIDE  FITPAD 0

DCREAD GUI TO lStatus OPTIONS GetOptions FIT MODAL EVAL {|o|SetAppWindow(o)} SETFOCUS "GET1" ENTEREXIT OWNER oBrowse APPWINDOW oDialog


oBarEdit:destroy()

// restore browse rows
oBrowse:enable()
oBrowse:up(.F.)
oBrowse:hilite()


RETURN NIL




